<template>
  <a-row type="flex" justify="center">
    <a-col :span="24">
      <a-page-header title="Bestellen"></a-page-header>
      <a-row type="flex" justify="center">
        <a-col :sm="24" :md="20" :lg="16">
          <a-list item-layout="horizontal" :data-source="items" :loading="loading" :bordered="true"
                  header="Bestellübersicht">
            <a-list-item slot="renderItem" slot-scope="item, index">
              <a-list-item-meta
                :description="item.product.product.description"
              >
                <a slot="title" :href="'/products/' + item.product.product.id">{{ item.product.fullName }}</a>
                <a-avatar
                  slot="avatar"
                  size="large"
                  :src="getImageUrl(item)"
                />
              </a-list-item-meta>
              <a-row type="flex" justify="end" :gutter="20" :style="{ flex: '1 0 auto' }">
                <a-col>
                  <a-statistic class="price--smaller" :precision="2" :value="item.product.product.price"
                               suffix="€"></a-statistic>
                </a-col>
                <a-col>
                  <a-input-number :disabled="true" size="large" :min="1" :max="item.product.inStock"
                                  v-model="{ ...item }.amount"/>
                </a-col>
              </a-row>
            </a-list-item>
            <div slot="footer" class="list-footer">
              <a-statistic title="Gesamt" :precision="2" :value="totalPrice" suffix="€"></a-statistic>
            </div>
          </a-list>
        </a-col>
      </a-row>
      <br>
      <br>
      <a-row type="flex" justify="center">
        <a-col :sm="24" :md="20" :lg="16">
          <h2>Bestelldaten</h2>
          <p>Bitte geben Sie Ihre Bestelldaten an</p>
          <a-form-model
            ref="orderForm"
            :model="data"
            :rules="rules"
            layout="horizontal"
            @submit="onSubmit"
            :label-col="{ xs: 24, sm: 4, lg: 6 }"
            :wrapper-col="{ sxs: 24, sm: 14 }"
          >
            <a-form-model-item ref="firstName" label="Vorname" prop="firstName">
              <a-input
                v-model="data.firstName"
                placeholder="Vorname"
              />
            </a-form-model-item>
            <a-form-model-item ref="lastName" label="Nachname" prop="lastName">
              <a-input
                v-model="data.lastName"
                placeholder="Nachname"
              />
            </a-form-model-item>
            <a-form-model-item ref="email" label="E-Mail Adresse" prop="email">
              <a-input
                v-model="data.email"
                type="email"
                placeholder="email@beispiel.de"
              />
            </a-form-model-item>
            <a-form-model-item ref="phone" label="Telefonnummer" prop="phone">
              <a-input
                v-model="data.phone"
                type="phone"
                placeholder="+49123456789"
              />
            </a-form-model-item>
          </a-form-model>
        </a-col>
      </a-row>
      <a-row type="flex" justify="center">
        <a-col :sm="24" :md="20" :lg="16">
          <a-button type="primary" block size="large" icon="shopping-cart" @click="onSubmit">
            Jetzt bestellen
          </a-button>
        </a-col>
      </a-row>
      <a-modal v-model="successful" title="Bestellung erfolgreich" :closable="false">
        <a-result
          status="success"
          title="Bestellung ist eingegangen"
          sub-title="Wir kontaktieren Sie per E-Mail wenn Ihre Bestellung abholbereit ist über das weitere Vorgehen"
        >
        </a-result>
        <template slot="footer">
          <a-button key="submit" type="primary" @click="handleSuccessModalClose">
            OK
          </a-button>
        </template>
      </a-modal>
    </a-col>
  </a-row>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data () {
    return {
      loading: true as boolean,
      successful: false as boolean,
      data: {
        firstName: '' as string,
        lastName: '' as string,
        email: '' as string,
        phone: '' as string
      },
      rules: {
        firstName: [
          { required: true, message: 'Bitte geben Sie Ihren Vornamen an', trigger: 'blur' },
          { min: 3, message: 'Die Eingabe sollte mindestens 3 Zeichen betragen', trigger: 'blur' }
        ],
        lastName: [
          { required: true, message: 'Bitte geben Sie Ihren Nachnamen an', trigger: 'blur' },
          { min: 3, message: 'Die Eingabe sollte mindestens 3 Zeichen betragen', trigger: 'blur' }
        ],
        email: [
          { required: true, message: 'Bitte geben Sie Ihre E-Mail Adresse an', trigger: 'blur' },
          { type: 'email', message: 'Bitte geben Sie eine gültige E-Mail Adresse an', trigger: 'blur' }
        ],
        phone: [
          {
            type: 'string',
            message: 'Bitte geben Sie eine gültige Telefonnummer an (bspw. +49123456789)',
            trigger: 'blur'
          }
        ]
      }
    }
  },
  computed: {
    items (): Array<any> {
      return this.$store.state.cart.currentItems
    },
    totalPrice (): number {
      return this.items.reduce((acc, current) => {
        return acc + current.amount * current.product.product.price
      }, 0)
    }
  },
  methods: {
    getImageUrl (item: any) {
      if (!item.product.product.images || item.product.product.images.length === 0) {
        return ''
      }
      if (item.product.product.images[0].url.startsWith('http')) {
        return item.product.product.images[0].url
      }
      return `${process.env.strapiBaseUri}${item.product.product.images[0].url}`
    },
    onSubmit() {
      // @ts-ignore
      this.$refs.orderForm.validate(async valid => {
        if (!valid) {
          this.$message.error('Bitte überprüfen Sie Ihre angegebenen Daten');
          return false
        }
        try {
          await this.$axios.post('/orders', {
            user: this.data,
            Item: this.items.map((item) => {
              return {
                product: item.product.id,
                amount: item.amount
              }
            })
          })
          this.successful = true
        } catch {
          this.$notification.error({
            message: 'Ein Fehler ist aufgetreten',
            description: 'Bitte prüfen Sie die Verfügbarkeit der Artikel, andernfalls kontaktieren Sie bitte den Support',
            duration: 10
          })
        }
      });
    },
    handleSuccessModalClose() {
      this.successful = false
      // TODO Clear Cart and maybe redirect
    }
  },
  mounted () {
    setTimeout(() => {
      this.loading = false
    }, 1500)
  },
  beforeUpdate () {
    if (this.items.length > 0) {
      this.loading = false
    }
  }
})
</script>

<style lang="scss">
.price--smaller {
  .ant-statistic-content {
    .ant-statistic-content-value-int {
      font-size: 20px
    }

    .ant-statistic-content-value-decimal, .ant-statistic-content-suffix {
      font-size: 14px;
    }
  }
}
</style>
<style lang="scss" scoped>
.list-footer {
  text-align: right;
}
</style>
